https://leetcode.com/problems/capacity-to-ship-packages-within-d-days/
https://leetcode.com/problems/capacity-to-ship-packages-within-d-days/discuss/259944/Java-binary-search
A conveyor belt has packages that must be shipped from one port to another within
D
days.
The
i
-th package on the conveyor belt has a weight of weights[i]
. Each day, we load the ship with packages on the conveyor belt (in the order given by weights
). We may not load more weight than the maximum weight capacity of the ship.
Return the least weight capacity of the ship that will result in all the packages on the conveyor belt being shipped within
D
days.
Example 1:
Input: weights = [1,2,3,4,5,6,7,8,9,10], D = 5 Output: 15 Explanation: A ship capacity of 15 is the minimum to ship all the packages in 5 days like this: 1st day: 1, 2, 3, 4, 5 2nd day: 6, 7 3rd day: 8 4th day: 9 5th day: 10 Note that the cargo must be shipped in the order given, so using a ship of capacity 14 and splitting the packages into parts like (2, 3, 4, 5), (1, 6, 7), (8), (9), (10) is not allowed.
Example 2:
Input: weights = [3,2,2,4,1,4], D = 3 Output: 6 Explanation: A ship capacity of 6 is the minimum to ship all the packages in 3 days like this: 1st day: 3, 2 2nd day: 2, 4 3rd day: 1, 4
Example 3:
Input: weights = [1,2,3,1,1], D = 4 Output: 3 Explanation: 1st day: 1 2nd day: 2 3rd day: 3 4th day: 1, 1
Note:
1 <= D <= weights.length <= 50000
1 <= weights[i] <= 500
- 这里, 每天最少的运力应该至少是货物的最大重量, 否则这个最重的货物就无法运输了
- 最大的运力就是所有货物的重量和, 相当于一天之内全部运完了
- 那么,我们确定了这个解的上限和下限, 那么,可以用二分搜索来查找符合要求的最佳解
- 给定一个运力, 我们需要计算需要多少天可以把货物运输完。 按顺序计算目前的重量, 如果超时了就重新开始一天就好
- 对于任何一个运力,知道需要多少天以后,我们需要修改上限和下限, 这里需要仔细一点,
– 如果middays < D, 那就不符合要求,运力太少了,运力一定是需要增加, 那么一定是low=mid+1
– 如果middays == D, 那有可能当前的运力是答案, 因为可能运力减少1以后就不符合要求了, 所以这里设置high=mid
– 如果middays > D, 同样,这时候也应该设置high=mid, 因为运力减少1以后也有可能不符合要求
public int shipWithinDays(int[] weights, int D) {
int low = 0;
int high = 0;
for(int weight: weights) {
high += weight;
low = Math.max(low, weight);
}
while(low < high) {
int mid = low + (high-low)/2;
int middays = calcDays(weights, mid);
if(middays < D) {
high = mid; // mid-1?
}
else if(middays == D) {
high = mid;
}
else { // > D
low = mid+1;
}
}
return low;
}
public int calcDays(int[] weights, int capacity) {
int count = 1;
int cursum = 0;
for(int weight: weights) {
if(cursum + weight > capacity) {
count++;
cursum = weight;
}
else { // <= capacity
cursum += weight;
}
}
return count;
}
https://leetcode.com/problems/capacity-to-ship-packages-within-d-days/discuss/259944/Java-binary-search
public int shipWithinDays(int[] weights, int D) {
// use binary search to find the optimal weight
int low = 1, high = 25000000;
while (low <= high) {
int mid = (low + high) / 2;
boolean can = canShip(weights, D, mid);
if (can) {
high = mid - 1;
} else {
low = mid + 1;
}
}
return low;
}
// check whether can ship under the given D and capacity
private boolean canShip(int[] weights, int D, int capacity) {
int day = 1, w = 0;
for (int i = 0; i < weights.length; i++) {
if (weights[i] > capacity || day > D) return false;
if (w + weights[i] > capacity) {
w = weights[i];
day++;
} else {
w += weights[i];
}
}
return day <= D;
}
https://leetcode.com/problems/capacity-to-ship-packages-within-d-days/discuss/256729/JavaC%2B%2BPython-Binary-Search
Given the number of bags,
return the minimum capacity of each bag,
so that we can put items one by one into all bags.
return the minimum capacity of each bag,
so that we can put items one by one into all bags.
Similar as
875. Koko Eating Bananas
774. Minimize Max Distance to Gas Station
875. Koko Eating Bananas
774. Minimize Max Distance to Gas Station
Java
public int shipWithinDays(int[] weights, int D) {
int left = 0, right = 0;
for (int w: weights) {
left = Math.max(left, w);
right += w;
}
while (left < right) {
int mid = (left + right) / 2, need = 1, cur = 0;
for (int w: weights) {
if (cur + w > mid) {
need += 1;
cur = 0;
}
cur += w;
}
if (need > D) left = mid + 1;
else right = mid;
}
return left;
}